package com.theone.android.lib.commons;

import java.util.LinkedList;
import java.util.Queue;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Executors;
import java.util.concurrent.RejectedExecutionHandler;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * ̳߳ع(߳ͳһȹ)
 */
public final class ThreadPoolManager {

	private static ThreadPoolManager sThreadPoolManager = new ThreadPoolManager();

	// ̳߳ά̵߳
	private static final int SIZE_CORE_POOL = 3;

	// ̳߳ά̵߳
	private static final int SIZE_MAX_POOL = 4;

	// ̳߳ά߳Ŀʱ
	private static final int TIME_KEEP_ALIVE = 5000;

	// ̳߳ʹõĻдС
	private static final int SIZE_WORK_QUEUE = 500;

	// 
	private static final int PERIOD_TASK_QOS = 1000;

	/*
	 * ̳߳ص
	 */
	public static ThreadPoolManager newInstance() {
		return sThreadPoolManager;
	}

	// 񻺳
	private final Queue<Runnable> mTaskQueue = new LinkedList<Runnable>();

	/*
	 * ̳߳سʱ뻺
	 */
	private final RejectedExecutionHandler mHandler = new RejectedExecutionHandler() {
		@Override
		public void rejectedExecution(Runnable task, ThreadPoolExecutor executor) {
			mTaskQueue.offer(task);
		}
	};

	/*
	 * е¼ص̳߳
	 */
	private final Runnable mAccessBufferThread = new Runnable() {
		@Override
		public void run() {
			if (hasMoreAcquire()) {
				mThreadPool.execute(mTaskQueue.poll());
			}
		}
	};

	/*
	 * һ̳߳
	 */
	private final ScheduledExecutorService scheduler = Executors.newScheduledThreadPool(1);

	/*
	 * ͨ߳Եִл
	 */
	protected final ScheduledFuture<?> mTaskHandler = scheduler.scheduleAtFixedRate(mAccessBufferThread, 0,
			PERIOD_TASK_QOS, TimeUnit.MILLISECONDS);

	/*
	 * ̳߳
	 */
	private final ThreadPoolExecutor mThreadPool = new ThreadPoolExecutor(SIZE_CORE_POOL, SIZE_MAX_POOL,
			TIME_KEEP_ALIVE, TimeUnit.SECONDS, new ArrayBlockingQueue<Runnable>(SIZE_WORK_QUEUE), mHandler);

	/*
	 * 췽ηΪ˽Уֹʵ
	 */
	private ThreadPoolManager() {
	}

	public void perpare() {
		if (mThreadPool.isShutdown() && !mThreadPool.prestartCoreThread()) {
			@SuppressWarnings("unused")
			int startThread = mThreadPool.prestartAllCoreThreads();
		}
	}

	/*
	 * Ϣм鷽
	 */
	private boolean hasMoreAcquire() {
		return !mTaskQueue.isEmpty();
	}

	/*
	 * ̳߳񷽷
	 */
	public void addExecuteTask(Runnable task) {
		if (task != null) {
			mThreadPool.execute(task);
		}
	}

	protected boolean isTaskEnd() {
		if (mThreadPool.getActiveCount() == 0) {
			return true;
		} else {
			return false;
		}
	}

	public void shutdown() {
		mTaskQueue.clear();
		mThreadPool.shutdown();
	}
}
